﻿
var emilCreature = new Creature { Name = "Emil" };
var shelobCreature = new Creature { Name = "Shelob" };  // Note: "Odula" in Czech

{
	int creaturesKilled = from c in emilCreature orderby c.Name.StartsWith("S") select c;
	Console.WriteLine($"Creatures killed: {creaturesKilled}");
}

{
	int creaturesKilled = from c in shelobCreature orderby c.Name.StartsWith("S") select c;
	Console.WriteLine($"Creatures killed: {creaturesKilled}");
}

class Creature {
	public string Name { get; init; }

	public int OrderBy(Predicate<Creature> predicate) { 
		if (predicate(this)) {
            Console.WriteLine($"Creature {Name} has been KILLED !!!");
			return 1;
        } else {
			Console.WriteLine($"Creature {Name} survived :)");
			return 0;
		}
	}
}
